VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MCICmd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'           VBǰߡhttp://vbbattlefront.163.net
'************************************************************
'*                   VB  ϵйʾ                   *
'*                                                          *
'*     ִ˳κβ֮ҪĽĵط *
'* ұˣ˽ǳмһл         *
'*                                                          *
'*                 by (Xing) my Email:vbxing@990.net  *
'************************************************************
'*š017
'*    ܡϢWAVEļ
'*    ڡ3/20/1999
'************************************************************

'****************************************************************
'*   Class Name:        MCICmd
'*   Author:            CHI XINGZE (Xing)
'*   Date  :            3/23/1999
'*
'****************************************************************
Option Explicit

Private Type MCI_WAVE_OPEN_PARMS
    dwCallback As Long
    wDeviceID As Long
    lpstrDeviceType As String
    lpstrElementName As String
    lpstrAlias As String
    dwBufferSeconds As Long
End Type

Private Type MCI_PLAY_PARMS         '˽ṹMCI_PLAYϢ
    dwCallback As Long
    dwFrom As Long
    dwTo As Long
End Type

Private Const MCI_OPEN& = &H803
Private Const MCI_CLOSE& = &H804
Private Const MCI_PLAY& = &H806
Private Const MCI_OPEN_TYPE& = &H2000&            '򿪵豸
Private Const MCI_OPEN_ELEMENT& = &H200&          '
Private Const MCI_WAIT& = &H2&

Private Declare Function mciSendCommand& Lib "winmm.dll" Alias "mciSendCommandA" (ByVal wDeviceID As Long, ByVal uMessage As Long, ByVal dwParam1 As Long, ByRef dwParam2 As Any)
Private Declare Function mciGetErrorString& Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal dwError As Long, ByVal lpstrBuffer As String, ByVal uLength As Long)




'Global members of the class
Private m_FIleName As String
Private m_ErrorString As String * 128

'****************************************************************
'*  Properties:  FileName -> Wave file name
'****************************************************************
Public Property Let FileName(s As String)
         m_FIleName = s
End Property

'****************************************************************
'  Properties:  MCIError -> MCI Error String
'****************************************************************
Public Property Get MCIError() As String
         MCIError = m_ErrorString
End Property

'****************************************************************
'*  PlaySound : MCI ṹϵͳ Wave ļ
'****************************************************************
Public Function PlaySound() As Boolean
    Dim Throw As Long
    Dim MCIErrorVal As Long
    Dim MCIWaveOpenParms As MCI_WAVE_OPEN_PARMS
    Dim MCIPlayParms As MCI_PLAY_PARMS
    
    MCIWaveOpenParms.dwCallback = 0&
    MCIWaveOpenParms.wDeviceID = 0&
    MCIWaveOpenParms.lpstrDeviceType = "waveaudio"
    MCIWaveOpenParms.lpstrElementName = m_FIleName
    MCIWaveOpenParms.lpstrAlias = 0&
    MCIWaveOpenParms.dwBufferSeconds = 0&
    

    
    MCIPlayParms.dwCallback = 0
    MCIPlayParms.dwFrom = 0
    MCIPlayParms.dwTo = 0
    
    'Open
    MCIErrorVal = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE Or MCI_OPEN_ELEMENT, _
                         MCIWaveOpenParms)       'УMCI_OPEN_TYPE Or MCI_OPEN_ELEMENT ñ־λ
    If CheckError(MCIErrorVal) = False Then PlaySound = False: Exit Function
    
    'Play
    MCIErrorVal = mciSendCommand(MCIWaveOpenParms.wDeviceID, MCI_PLAY, MCI_WAIT, MCIPlayParms)
    If CheckError(MCIErrorVal) = False Then PlaySound = False: Exit Function
    
    'Close
    MCIErrorVal = mciSendCommand(MCIWaveOpenParms.wDeviceID, MCI_CLOSE, 0, 0)
    If CheckError(MCIErrorVal) = False Then PlaySound = False: Exit Function
    
    PlaySound = True
End Function

'****************************************************************
'*  CheeckError  :    ȡϵͳһεĴϢ
'****************************************************************
Public Function CheckError(MCIErrorVal) As Boolean
    Dim Throw As Long
    Throw = mciGetErrorString(MCIErrorVal, m_ErrorString, 255)
    If Throw = 1 Then
        CheckError = True
    Else
        CheckError = False
    End If
End Function

'****************************************************************
'****************************************************************
